

#############################################################################
# Copyright (C) Labomedia May 2012
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software Foundation,
#  Inc., 51 Franproplin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
#############################################################################
#
## send_data.py
#
#  This script run every frame and send OSC message to the server via Relay.
#
#############################################################################

import GameLogic as gl
from OSC3.OSC import OSCClient, OSCMessage

level = gl.level
my_name = gl.my_name
name = gl.name

# Get all scenes
scenes = gl.getSceneList()

addr_out = gl.local_ip, gl.port_out
clt = OSCClient()
clt.connect(addr_out)

def send_message(title, message):
    m = OSCMessage(title)
    m.append(message)
    try:
        clt.send(m)
        #print(m)
    except:
        pass

## Create data used in /player_data message
# Default value
score = [7]
bat_loc = [-8.25, 6.37]
ball_loc = [0, 0]
# My rank
try:
    rank = name[my_name]
except:
    rank = 0

for scen in scenes:
    for obj in scen.objects:
        # Ball
        if "ball" in str(obj) :
            ball_loc = [obj.localPosition[0], obj.localPosition[1]]
        # Bat and score
        if "activ" in obj :
            if obj["activ"] == 1:
                if "goal" in str(obj) :
                    score = obj["score"]
                if "bat" in str(obj) :
                    bat_loc = [obj.localPosition[0], obj.localPosition[1]]
        # Text SendOSC: used to send quit, reset, new ...
        if str(obj) == "SendOSC":
            gl.sendosc = obj

# Create msg with good datas or this player
send_message('/player_data', ['/ball', ball_loc, '/bat', bat_loc, '/score', score,
            '/name', my_name, '/rank', rank])

# Quit
if gl.sendosc["quit"]:
    send_message('/quit', 1)

# Reset
if gl.sendosc["reset"]:
    send_message('/reset', 1)

# New Game
if gl.sendosc["new_game"]:
    send_message('/new_game', 1)
    print('New Game')
